#include <stdio.h>
#include <stdlib.h>
#include "velikibroj.h"
#include <string.h>

int vbcmp(VB a, VB b)
{
	int i;
	//dozvolicemo pretpostavku
	//da ni jedan broj ne pocinje nulom
	//moguca pojava baga ako je
	//broj na primer "000001" i "123"
	
	if(a.n - b.n != 0)
		return a.n - b.n;
	
	/*moze i b.n-1*/
	for(i = a.n-1 ; i >= 0; i--)
		if(a.broj[i] - b.broj[i] != 0)
			return a.broj[i] - b.broj[i];
	
	return 0;
}

VB saberi(VB a, VB b)
{
	int i;
	VB r;
	//prenos       0 1 0
	//a      1 2 3 4 5 9
	//b      1 6 7 2 3 8
	//r              9 7
	
	int prenos = 0;
	//duzina jednog broja
	//duzina drugog broja
	//duzina rezultata ce biti duzina veceg
	//eventualno +1
	
	int max_n = a.n > b.n ? a.n : b.n;
	r.n = max_n;
	
	for(i = 0; i < max_n; i++)
	{
		int trenutni = prenos;
		if(i < a.n)
			//treba da sabiramo cifru iz a
			trenutni += a.broj[i];
		if(i < b.n)
			//treba da sabiramo cifru iz b
			trenutni += b.broj[i];
		
		r.broj[i] = trenutni % 10;
		prenos = trenutni / 10;
	}
	
	if(prenos > 0)
	{
		r.broj[r.n] = prenos;
		r.n++;
	}
	
	return r;
}
VB oduzmi(VB a, VB b)
{
	//ZA DOMACI
	VB r;
	return r;
}
VB mnozi_cifrom(VB a, int b)
{
	// za domaci probati soprij implementaciju
	//kada se b puta zove sabiranje
	
	//1 2 3 4 5 6 7 8 * 9
	int i;
	VB r;
	int prenos = 0;
	
	if(b == 0)
	{
		r.n = 0;
		return r;
	}
	
	r.n = a.n;
	for(i = 0; i < a.n; i++)
	{
		int temp = prenos;
		temp += b * a.broj[i];
		r.broj[i] = temp % 10;
		prenos = temp / 10;
	}
	if(prenos > 0)
	{
		r.broj[r.n] = prenos;
		r.n++;
	}
	
	return r;
}
VB nula()
{
	VB r;
	r.n = 0;
	return r;
}
VB mnozi_sa_deset_na_k(VB a, int k)
{
	int i, j;
	VB r;
	r.n = 0;
	for(i = 0; i < k; i++)
	{
		r.broj[i] = 0;
		r.n++;
	}
	for(j = 0; j < a.n; j++)
	{
		r.broj[i] = a.broj[j];
		r.n++;
		i++;
	}
	return r;
}

VB mnozi(VB a, VB b)
{
	int i;
	VB r = nula();
	for(i = 0; i < b.n; i++)
	{
		//algoritam mnozenja
		VB temp = mnozi_cifrom(a, b.broj[i]);
		temp = mnozi_sa_deset_na_k(temp, i);
		r = saberi(r, temp);
	}
	return r;
}
VB ucitaj(char *s)
{
	VB r;
	int n = strlen(s);
	r.n = n;
	
	int i;
	int j = 0;
	for(i = n - 1; i >= 0; i--)
	{
		r.broj[j] = s[i] - '0';
		j++;
	}
	return r;
}
void ispis(VB a)
{
	int i;
	for(i = a.n - 1; i >= 0; i--)
		putchar(a.broj[i] + '0');
	printf("\n");
}