#include "velikibroj.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

VB zbir(VB a, VB b)
{
	VB r;
	// 0             1 1 0
	//   1 2 3 4 5 6 7 8 9
	//   1 2 3 4 5 6 7 8 9
	//   2             7 8
	int prenos = 0;
	int brc = a.n > b.n ? a.n : b.n;
	int i;
	
	r.n = brc;
	
	for(i = 0; i < brc; i++)
	{
		//ovo nije dobro jer smo mozda vec
		//stigli do kraja nekog broja
		//int vrednost = prenos + a.cifre[i] + b.cifre[i];
		
		int vrednost = prenos;
		//da li treba da racunamo a
		if(i < a.n)
			vrednost += a.cifre[i];
		if(i < b.n)
			vrednost += b.cifre[i];
		
		//18
		r.cifre[i] = vrednost % 10;
		prenos = vrednost / 10;
	}
	if(prenos > 0)
	{
		r.cifre[r.n] = prenos;
		r.n++;
	}
	return r;
}
VB razlika(VB a, VB b)
{
	VB r;
	//za domaci
	return r;
}
int cmpvb(VB a, VB b)
{
	//podrazumevamo da broj ne pocinje nulama
	//ako pocinje nulama pojavice se bag
	
	//ne moze "0000001234"
	//nego mora "1234"
	
	//poredimo duzine
	//"12345" - 5
	//"123" - 3
	
	//ne uzimamo u obzir
	//"12345"
	//"0000123"
	
	//ako su duzine razlicite
	int i;
	if(a.n != b.n)
		return a.n - b.n;
	
	//ovde ce program doci samo
	//ako su brojevi iste duzine
	
	for(i = a.n - 1; i >= 0; i--)
	{
		//poredimo cifra po cifra
		if(a.cifre[i] != b.cifre[i])
			return a.cifre[i] - b.cifre[i];
	}
	return 0;
}

VB mnozi_cifrom(VB a, int b)
{
	VB r;
	int prenos = 0;
	int i;
	
	if(b == 0)
	{
		r = nula();
		return r;
	}
	
	r.n = a.n;
	for(i = 0; i < a.n; i++)
	{
		int vrednost = prenos + b * a.cifre[i];
		r.cifre[i] = vrednost % 10;
		prenos = vrednost / 10;
	}
	if(prenos > 0)
	{
		r.cifre[r.n] = prenos;
		r.n++;
	}
	return r;
}

VB puta_deset_na_k(VB a, int k)
{
	VB r;
	int i, j;
	//zapisujemo k nula na pocetak
	for(i = 0; i < k; i++)
		r.cifre[i] = 0;
	
	//1234
	//0000001234
	//posle prepisujemo broj a
	for(j = 0; j < a.n; j++)
	{
		r.cifre[i] = a.cifre[j];
		i++;
	}
	r.n = k + a.n;
	return r;
}

VB nula()
{
	VB r;
	r.n = 0;
	return r;
}

VB mnozi(VB a, VB b)
{
	VB r = nula();
	
	//da bi smo implementirali mnozenje
	//moramo da implementiramo mnozenje cifrom
	
	int i;
	for(i = 0; i < b.n; i++)
	{
		VB temp = mnozi_cifrom(a, b.cifre[i]);
		temp = puta_deset_na_k(temp, i);
		r = zbir(r, temp);
	}
	
	return r;
}
VB unos(char *s)
{
	int i, j;
	VB r;
	r.n = strlen(s);
	
	j = 0;
	for(i = r.n - 1; i >= 0; i--)
	{
		r.cifre[j] = s[i] - '0';
		j++;
	}
	return r;
}
void ispis(VB a)
{
	int i;
	for(i = a.n - 1; i >= 0; i--)
		putchar(a.cifre[i] + '0');
	putchar('\n');
}